#!/bin/sh
#set -x
# script to translate paths into backuppc files
# written by Adrian Bridgett
# backuppc_ls -a "/var/lib/mysql/gld/grey*"

topdir="/var/lib/backuppc"

set -e

usage()
{
  cat <<EOF
Usage: `basename $0` -a|-h hostname path

EOF
  exit 1
}

main()
{
  hosts=""
  while getopts "ah:" opt; do
    case "$opt" in
      h) hosts="$hosts $OPTARG";;
      a) hosts=`/bin/ls "$topdir/pc"`;;
    esac
  done
  shift $(($OPTIND - 1))
  # ensure leading slash but no trailing slash
  for path in "$@"; do
    glob="/${path#/}"
    glob="${glob%/}"
    glob=`echo "$glob" | sed 's/\//\/f/g'`

    [ "$hosts" ] && [ "$glob" ] || usage

    for host in $hosts; do
      print_ls $host "$glob"
    done
  done
}

print_ls()
{
  local host="$1"
  local glob="$2"
  echo $topdir/pc/$host/[0-9]*/f*$glob 2>/dev/null 
  cd $topdir/pc/$host/[0-9]*/f*
   ls -d ".$glob"  || true
#  ls -d "$topdir/pc/$host/[0-9]*/f*$glob" 2>/dev/null || true
}

main "$@"


