#!/bin/bash
# GPL V3
# v1.0 higuita@gmx.net 2010-10-05

# cron job to check the logs and replace the error with
# a better message on why backups failed 
# outputs to screen and replace the error in the log
# 45 *  * * *	/etc/backuppc/bin/test-ssh.sh >> /var/log/backuppc.log

#set -x
cd /backuppc/backuppc/pc
date "+%Y-%m-%d %H:%M"
(
for i in *; do 
	err=0
	a=`tail -n 1 $i/LOG.*[0-9] | grep "Unable to read 4 bytes\|inet connect"`
	type=`fgrep XferMethod /etc/backuppc/$i.pl | sed "s/.*'\(.*\)'.*/\1/g"`
	type=${type:=*nix}


	case "$a" in 
		[0-9]*) 
			file=`ls -1 $i/LOG.*[0-9]`

			# does the SSH is on? needed by the rsync backup
			b=`nmap -p 22,445 -O  $i 2>/dev/null |grep "22/tcp\|Running"` 

			# what OS? unix use rsync via ssh, windows rsyncd, no ssh
			OS=`echo $b| sed -n  's/.*: \([^ ]* [^ ]* [^ ]*\).*/\1/gp'`
			if  echo $b | grep "22/tcp.*open" > /dev/null; then
				echo $a | \
				sed "s/Unable to read 4 bytes|inet connect.*/ssh error - $OS/g " >> $file
				echo "$i		ssh	$type	$OS"
			else
				echo $a | \
				sed "s/Unable to read 4 bytes|inet connect.*/no_ssh - $OS/g " >> $file
				echo "$i		off	$type	$OS"
			fi
		;;
		*)	
		;;
	esac
done


) | sort -k +3 | column -t

